/*
 * generated by Fujaba - CodeGen2
 */
package de.uni_kassel.pmss10.mancala;
import java.util.Collections;
import java.util.Iterator;
import java.util.Set;

import de.upb.tools.fca.FEmptyIterator;
import de.upb.tools.fca.FHashSet;


public class Pit
{



   /**
    * <pre>
    *           0..1     counterpart     0..1
    * Pit ------------------------- Pit
    *           revCounterpart               counterpart
    * </pre>
    */

   private Pit counterpart;

   public boolean setCounterpart (Pit value)
   {
      boolean changed = false;

      if (this.counterpart != value)
      {
      
         Pit oldValue = this.counterpart;
         Pit source = this;
         if (this.counterpart != null)
         {
            this.counterpart = null;
            oldValue.setRevCounterpart (null);
         }
         this.counterpart = value;

         if (value != null)
         {
            value.setRevCounterpart (this);
         }
         changed = true;
      
      }
      return changed;
   }

   public Pit withCounterpart (Pit value)
   {
      setCounterpart (value);
      return this;
   }

   public Pit getCounterpart ()
   {
      return this.counterpart;
   }

   /**
    * <pre>
    *           0..1     pit     0..1
    * Pit ------------------------- Mancala
    *           pit               mancala
    * </pre>
    */

   private Mancala mancala;

   public boolean setMancala (Mancala value)
   {
      boolean changed = false;

      if (this.mancala != value)
      {
      
         Mancala oldValue = this.mancala;
         Pit source = this;
         if (this.mancala != null)
         {
            this.mancala = null;
            oldValue.removeFromPit (this);
         }
         this.mancala = value;

         if (value != null)
         {
            value.addToPit (this);
         }
         changed = true;
      
      }
      return changed;
   }

   public Pit withMancala (Mancala value)
   {
      setMancala (value);
      return this;
   }

   public Mancala getMancala ()
   {
      return this.mancala;
   }

   public void moveStones ()
   {
      // TODO: This method is not fully implemented
      // regarding to the offical PM Mancala rules!!
      
		Pit nextPit = getNext();
		for (Iterator<? extends Stone> iter = iteratorOfStones(); iter.hasNext();) {
			Stone stone = iter.next();
			
			boolean capture = false;
			Pit counterpart = nextPit.findCounterpart();

			// Check if this is the last stone and 
			// if can catch stones
			if(getStones().size() == 1)
			{
				if(nextPit.getStones().isEmpty())
				{
				   if(counterpart != null && !counterpart.getStones().isEmpty())
				   {
				      capture = true;
				   }
				}
			}
			
			if(capture)
			{
				// Put the stone and all stones 
				// of the counterparts pit into 
				// the players kalah
				Pit kalah = null;
				while(kalah == null && !(kalah instanceof Kalah))
				{
				   kalah = nextPit.getNext();
				}
				kalah.addToStones(stone);
				for (Iterator<? extends Stone> enemyIter = counterpart.iteratorOfStones(); enemyIter.hasNext();) 
				{
					kalah.addToStones(enemyIter.next());
				}
			}
			else
			{
				nextPit.addToStones(stone);
				nextPit = nextPit.getNext();
			}
			
		}
   }
   
   private Pit findCounterpart()
   {
      Pit counterpartPit = getCounterpart();
      if(counterpartPit == null)
      {
         counterpartPit = getRevCounterpart();
      }
      
      return counterpartPit;
   }

   /**
    * <pre>
    *           0..1     next     0..1
    * Pit ------------------------- Pit
    *           previous               next
    * </pre>
    */

   private Pit next;

   public boolean setNext (Pit value)
   {
      boolean changed = false;

      if (this.next != value)
      {
      
         Pit oldValue = this.next;
         Pit source = this;
         if (this.next != null)
         {
            this.next = null;
            oldValue.setPrevious (null);
         }
         this.next = value;

         if (value != null)
         {
            value.setPrevious (this);
         }
         changed = true;
      
      }
      return changed;
   }

   public Pit withNext (Pit value)
   {
      setNext (value);
      return this;
   }

   public Pit getNext ()
   {
      return this.next;
   }

   private int nr;

   public void setNr (int value)
   {
      this.nr = value;
   }

   public Pit withNr (int value)
   {
      setNr (value);
      return this;
   }

   public int getNr ()
   {
      return this.nr;
   }

   /**
    * <pre>
    *           0..n     pits     0..1
    * Pit ------------------------- Player
    *           pits               player
    * </pre>
    */

   private Player player;

   public boolean setPlayer (Player value)
   {
      boolean changed = false;

      if (this.player != value)
      {
      
         Player oldValue = this.player;
         Pit source = this;
         if (this.player != null)
         {
            this.player = null;
            oldValue.removeFromPits (this);
         }
         this.player = value;

         if (value != null)
         {
            value.addToPits (this);
         }
         changed = true;
      
      }
      return changed;
   }

   public Pit withPlayer (Player value)
   {
      setPlayer (value);
      return this;
   }

   public Player getPlayer ()
   {
      return this.player;
   }

   /**
    * <pre>
    *           0..1     next     0..1
    * Pit ------------------------- Pit
    *           next               previous
    * </pre>
    */

   private Pit previous;

   public boolean setPrevious (Pit value)
   {
      boolean changed = false;

      if (this.previous != value)
      {
      
         Pit oldValue = this.previous;
         Pit source = this;
         if (this.previous != null)
         {
            this.previous = null;
            oldValue.setNext (null);
         }
         this.previous = value;

         if (value != null)
         {
            value.setNext (this);
         }
         changed = true;
      
      }
      return changed;
   }

   public Pit withPrevious (Pit value)
   {
      setPrevious (value);
      return this;
   }

   public Pit getPrevious ()
   {
      return this.previous;
   }

   /**
    * <pre>
    *           0..1     counterpart     0..1
    * Pit ------------------------- Pit
    *           counterpart               revCounterpart
    * </pre>
    */

   private Pit revCounterpart;

   public boolean setRevCounterpart (Pit value)
   {
      boolean changed = false;

      if (this.revCounterpart != value)
      {
      
         Pit oldValue = this.revCounterpart;
         Pit source = this;
         if (this.revCounterpart != null)
         {
            this.revCounterpart = null;
            oldValue.setCounterpart (null);
         }
         this.revCounterpart = value;

         if (value != null)
         {
            value.setCounterpart (this);
         }
         changed = true;
      
      }
      return changed;
   }

   public Pit withRevCounterpart (Pit value)
   {
      setRevCounterpart (value);
      return this;
   }

   public Pit getRevCounterpart ()
   {
      return this.revCounterpart;
   }

   /**
    * <pre>
    *           0..1     stones     0..n
    * Pit ------------------------- Stone
    *           pit               stones
    * </pre>
    */

   private FHashSet<Stone> stones;

   public Set<? extends Stone> getStones()
   {
      return ((this.stones == null)
              ? Collections.EMPTY_SET
              : Collections.unmodifiableSet(this.stones));
   }

   public boolean addToStones (Stone value)
   {
      boolean changed = false;

      if (value != null)
      {
         if (this.stones == null)
         {
            this.stones = new FHashSet<Stone> ();

         }
      
         changed = this.stones.add (value);
         if (changed)
         {
            value.setPit (this);
         }
      
      }
      return changed;
   }

   public Pit withStones (Stone value)
   {
      addToStones (value);
      return this;
   }

   public Pit withoutStones (Stone value)
   {
      removeFromStones (value);
      return this;
   }


   public boolean removeFromStones (Stone value)
   {
      boolean changed = false;

      if ((this.stones != null) && (value != null))
      {
      
         changed = this.stones.remove (value);
         if (changed)
         {
            value.setPit (null);
         }
      
      }
      return changed;
   }

   public void removeAllFromStones (){
   
      Stone tmpValue;
      Iterator<? extends Stone> iter = this.iteratorOfStones ();
      while (iter.hasNext ())
      {
         tmpValue = (Stone) iter.next ();
         this.removeFromStones (tmpValue);
      }
   
   }

   public boolean hasInStones (Stone value)
   {
      return ((this.stones != null) &&
              (value != null) &&
              this.stones.contains (value));
   }

   public Iterator<? extends Stone> iteratorOfStones ()
   {
      return ((this.stones == null)
              ? FEmptyIterator.<Stone>get ()
              : this.stones.iterator ());
   }

   public int sizeOfStones ()
   {
      return ((this.stones == null)
              ? 0
              : this.stones.size ());
   }

   public void removeYou()
   {
      this.setCounterpart (null);
      this.setMancala (null);
      this.setNext (null);
      this.setPlayer (null);
      this.setPrevious (null);
      this.setRevCounterpart (null);
      this.removeAllFromStones ();
   }
}


